## -----------------------------------:
## This is a global library for pyxcom
## -----------------------------------
## Copyright (c) 2004-2007 Alessandro Pisa <alessandro...pisa@@@gmail...com>
## All rights reserved.
##
## Redistribution and use in source and binary forms, with or without
## modification, are permitted provided that the following conditions
## are met:
##
## 1. Redistributions of source code must retain the above copyright
##    notice, this list of conditions and the following disclaimer.
## 2. Redistributions in binary form must reproduce the above copyright
##    notice, this list of conditions and the following disclaimer in the
##    documentation and/or other materials provided with the distribution.
##
## THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
## IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
## OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
## IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
## INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
## NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
## DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
## THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
## (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
## THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

# generated by wxGlade 0.3.5.1 on Sun Jan 30 18:56:43 2005
import wx, pxglob

class MyDialog1(wx.Dialog):
    def __init__(self, *args, **kwds):
        wx.ID_CHKBOX=[wx.NewId() for i in range(8)]
        self.cols=[]
        self.pyxcommain=args[0]
        for i, col in enumerate(wx.ID_COLS):
            if self.pyxcommain.Pyxcom_menubar.IsChecked(col): self.cols.append(i)

        # begin wxGlade: MyDialog1.__init__
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE
        wx.Dialog.__init__(self, *args, **kwds)
        self.sizer_3_staticbox = wx.StaticBox(self, -1, "")
        self.sizer_1_staticbox = wx.StaticBox(self, -1, "Columns selection")
        self.sizer_2_staticbox = wx.StaticBox(self, -1, "Group operations")
        self.checkbox_1 = wx.CheckBox(self, wx.ID_CHKBOX[0], "Photon Energy (MeV)")
        self.checkbox_2 = wx.CheckBox(self, wx.ID_CHKBOX[1], "Coherent Scattering (cm2/g)")
        self.checkbox_3 = wx.CheckBox(self, wx.ID_CHKBOX[2], "Incoherent Scattering (cm2/g)")
        self.checkbox_4 = wx.CheckBox(self, wx.ID_CHKBOX[3], "Photoelectric Absorption (cm2/g)")
        self.checkbox_5 = wx.CheckBox(self, wx.ID_CHKBOX[4], "Pair Production In Nuclear Field (cm2/g)")
        self.checkbox_6 = wx.CheckBox(self, wx.ID_CHKBOX[5], "Pair Production In Electron Field (cm2/g)")
        self.checkbox_7 = wx.CheckBox(self, wx.ID_CHKBOX[6], "Total Attenuation With Coherent Scattering (cm2/g)")
        self.checkbox_8 = wx.CheckBox(self, wx.ID_CHKBOX[7], "Total Attenuation Without Coherent Scattering (cm2/g)")
        self.button_1 = wx.Button(self, wx.ID_COLS_ALL, "&Select all")
        self.button_2 = wx.Button(self, wx.ID_COLS_NONE, "&Unselect all")
        self.button_3 = wx.Button(self, wx.ID_CANCEL, "&Cancel")
        self.accept = wx.Button(self, wx.ID_SAVE, "&Accept")

        self.__set_properties()
        self.__do_layout()
        # end wxGlade

        self.checkboxes=[self.checkbox_1, self.checkbox_2, self.checkbox_3, self.checkbox_4,
                         self.checkbox_5, self.checkbox_6, self.checkbox_7, self.checkbox_8]
        for i in self.cols:
            self.checkboxes[i].SetValue(True)

        wx.EVT_BUTTON(self, wx.ID_COLS_ALL, self.OnColsAll)
        wx.EVT_BUTTON(self, wx.ID_COLS_NONE, self.OnColsNone)
        wx.EVT_BUTTON(self, wx.ID_SAVE, self.OnAccept)
        wx.EVT_BUTTON(self, wx.ID_CANCEL, self.OnCancel)

    def __set_properties(self):
        # begin wxGlade: MyDialog1.__set_properties
        self.SetTitle("dialog_2")
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: MyDialog1.__do_layout
        sizer_1 = wx.StaticBoxSizer(self.sizer_1_staticbox, wx.VERTICAL)
        sizer_3 = wx.StaticBoxSizer(self.sizer_3_staticbox, wx.HORIZONTAL)
        sizer_2 = wx.StaticBoxSizer(self.sizer_2_staticbox, wx.HORIZONTAL)
        sizer_1.Add(self.checkbox_1, 0, 0, 0)
        sizer_1.Add(self.checkbox_2, 0, 0, 0)
        sizer_1.Add(self.checkbox_3, 0, 0, 0)
        sizer_1.Add(self.checkbox_4, 0, 0, 0)
        sizer_1.Add(self.checkbox_5, 0, 0, 0)
        sizer_1.Add(self.checkbox_6, 0, 0, 0)
        sizer_1.Add(self.checkbox_7, 0, 0, 0)
        sizer_1.Add(self.checkbox_8, 0, 0, 0)
        sizer_2.Add(self.button_1, 0, 0, 0)
        sizer_2.Add((20, 20), 0, 0, 0)
        sizer_2.Add(self.button_2, 0, 0, 0)
        sizer_1.Add(sizer_2, 1, wx.EXPAND, 0)
        sizer_3.Add(self.button_3, 0, 0, 0)
        sizer_3.Add(self.accept, 0, 0, 0)
        sizer_1.Add(sizer_3, 1, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    def OnColsAll(self, event):
        for checkbox in self.checkboxes:
            checkbox.SetValue(True)

    def OnColsNone(self, event):
        for checkbox in self.checkboxes:
            checkbox.SetValue(False)

    def OnCancel(self, event):
        self.EndModal(0)

    def OnAccept(self, event):
        self.cols=[]
        for i, checkbox in enumerate(self.checkboxes):
            if checkbox.GetValue():
                self.cols.append(i)
                self.pyxcommain.Pyxcom_menubar.Check(wx.ID_COLS[i], True)
            else:
                self.pyxcommain.Pyxcom_menubar.Check(wx.ID_COLS[i], False)
        self.EndModal(0)


# end of class MyDialog1

class PathDialog(wx.Dialog):
    wx.ID_BROWSEEXEC=wx.NewId()
    wx.ID_BROWSEDATA=wx.NewId()

    def __init__(self, *args, **kwds):
        # begin wxGlade: PathDialog.__init__
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE
        wx.Dialog.__init__(self, *args, **kwds)
        self.data_inner_sizer_staticbox = wx.StaticBox(self, -1, "xcom executable")
        self.outer_sizer_staticbox = wx.StaticBox(self, -1, "Configure path")
        self.data_sizer_staticbox = wx.StaticBox(self, -1, "xcom data directory")
        self.label = wx.StaticText(self, -1, "Enter the correct path for your xcom installation")
        self.data_text_ctrl = wx.TextCtrl(self, -1, "")
        self.data_btn = wx.Button(self, wx.ID_BROWSEDATA, "&Browse")
        self.exec_text_ctrl = wx.TextCtrl(self, -1, "")
        self.exec_btn = wx.Button(self, wx.ID_BROWSEEXEC, "B&rowse")
        self.btn_OK = wx.Button(self, wx.ID_OK, "&Ok")
        self.btn_Cancel = wx.Button(self, wx.ID_CANCEL, "&Cancel")

        self.__set_properties()
        self.__do_layout()
        # end wxGlade
        wx.EVT_BUTTON(self, wx.ID_OK, self.OnClickOk)
        wx.EVT_BUTTON(self, wx.ID_BROWSEDATA, self.OnBrowseData)
        wx.EVT_BUTTON(self, wx.ID_BROWSEEXEC, self.OnBrowseExec)

    def __set_properties(self):
        # begin wxGlade: PathDialog.__set_properties
        self.SetTitle("pyxcom path configuration")
        # end wxGlade
        XCOMDIR, XCOMBIN=pxglob.read_conf()
        self.data_text_ctrl.SetValue(XCOMDIR)
        self.exec_text_ctrl.SetValue(XCOMBIN)

    def __do_layout(self):
        # begin wxGlade: PathDialog.__do_layout
        outer_sizer = wx.StaticBoxSizer(self.outer_sizer_staticbox, wx.VERTICAL)
        exec_inner_sizer = wx.BoxSizer(wx.HORIZONTAL)
        data_inner_sizer = wx.StaticBoxSizer(self.data_inner_sizer_staticbox, wx.HORIZONTAL)
        data_sizer = wx.StaticBoxSizer(self.data_sizer_staticbox, wx.HORIZONTAL)
        outer_sizer.Add(self.label, 0, wx.ALL, 10)
        data_sizer.Add(self.data_text_ctrl, 1, wx.ALL|wx.EXPAND, 10)
        data_sizer.Add(self.data_btn, 0, wx.ALL, 10)
        outer_sizer.Add(data_sizer, 1, wx.EXPAND, 0)
        data_inner_sizer.Add(self.exec_text_ctrl, 1, wx.ALL|wx.EXPAND, 10)
        data_inner_sizer.Add(self.exec_btn, 0, wx.ALL, 10)
        outer_sizer.Add(data_inner_sizer, 1, wx.EXPAND, 0)
        exec_inner_sizer.Add(self.btn_OK, 0, wx.ALL, 10)
        exec_inner_sizer.Add(self.btn_Cancel, 0, wx.ALL, 10)
        outer_sizer.Add(exec_inner_sizer, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        self.SetSizer(outer_sizer)
        outer_sizer.Fit(self)
        self.Layout()
        # end wxGlade

    def OnBrowseData(self, event):
        XCOMDIR=self.data_text_ctrl.GetValue()
        DirDialog=wx.DirDialog(self, "Where is installed xcom?", XCOMDIR, wx.DD_NEW_DIR_BUTTON)
        DirDialog.ShowModal()
        self.data_text_ctrl.SetValue(DirDialog.GetPath())

    def OnBrowseExec(self, event):
        XCOMDIR=self.data_text_ctrl.GetValue()
        FileDialog=wx.FileDialog(self, "Where is installed xcom?", XCOMDIR)
        FileDialog.ShowModal()
        self.exec_text_ctrl.SetValue(FileDialog.GetPath())

    def OnClickOk(self, event):
        XCOMDIR=self.data_text_ctrl.GetValue()
        XCOMBIN=self.exec_text_ctrl.GetValue()
        pxglob.update_conf(XCOMDIR, XCOMBIN)
        self.EndModal(0)

    def OnClickCancel(self, event):
        pass
# end of class PathDialog

class PyxcomFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        wx.ID_CALC=wx.NewId()
        wx.ID_CHPATH=wx.NewId()
        wx.ID_GETXCOM=wx.NewId()
        wx.ID_COLS=map(lambda x: wx.NewId(), range(8))
        wx.ID_COLS_ALL=wx.NewId()
        wx.ID_COLS_NONE=wx.NewId()
        wx.ID_COLGUI=wx.NewId()
        wx.ID_DEBUG=wx.NewId()

        self.data="Pyxcom\na python interface to xcom"
        self.debug="Pyxcom\na python interface to xcom"
        # begin wxGlade: PyxcomFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.Enotebook = wx.Notebook(self, -1, style=wx.NB_LEFT)
        self.Enotebook_3 = wx.Panel(self.Enotebook, -1)
        self.Enotebook_2 = wx.Panel(self.Enotebook, -1)
        self.Enotebook_1 = wx.Panel(self.Enotebook, -1)
        self.MSnotebook = wx.Notebook(self, -1, style=wx.NB_LEFT)
        self.MSnotebook_2 = wx.Panel(self.MSnotebook, -1)
        self.MSsizer_staticbox = wx.StaticBox(self, -1, "Material selection")
        self.Esizer_staticbox = wx.StaticBox(self, -1, "Energy selection (keV)")
        self.Msnotebook_1 = wx.Panel(self.MSnotebook, -1)

        # Menu Bar
        self.Pyxcom_menubar = wx.MenuBar()
        self.SetMenuBar(self.Pyxcom_menubar)
        wxglade_tmp_menu = wx.Menu()
        wxglade_tmp_menu.Append(wx.ID_CALC, "&Calculate", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.Append(wx.ID_SAVEAS, "&Save as...", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.AppendSeparator()
        wxglade_tmp_menu.Append(wx.ID_EXIT, "&Exit", "", wx.ITEM_NORMAL)
        self.Pyxcom_menubar.Append(wxglade_tmp_menu, "&File")
        wxglade_tmp_menu = wx.Menu()
        wxglade_tmp_menu_sub = wx.Menu()
        wxglade_tmp_menu_sub.Append(wx.ID_COLGUI, "&Selector ...", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu_sub.AppendSeparator()
        wxglade_tmp_menu_sub.Append(wx.ID_COLS[0], "&1 Energy", "", wx.ITEM_CHECK)
        wxglade_tmp_menu_sub.Append(wx.ID_COLS[1], "&2 Coherent", "", wx.ITEM_CHECK)
        wxglade_tmp_menu_sub.Append(wx.ID_COLS[2], "&3 Incoherent", "", wx.ITEM_CHECK)
        wxglade_tmp_menu_sub.Append(wx.ID_COLS[3], "&4 Photoelectric", "", wx.ITEM_CHECK)
        wxglade_tmp_menu_sub.Append(wx.ID_COLS[4], "&5 PP (Nuclear field)", "", wx.ITEM_CHECK)
        wxglade_tmp_menu_sub.Append(wx.ID_COLS[5], "&6 PP (Electron field)", "", wx.ITEM_CHECK)
        wxglade_tmp_menu_sub.Append(wx.ID_COLS[6], "&7 Total with coherent", "", wx.ITEM_CHECK)
        wxglade_tmp_menu_sub.Append(wx.ID_COLS[7], "&8 Total without coherent", "", wx.ITEM_CHECK)
        wxglade_tmp_menu_sub.AppendSeparator()
        wxglade_tmp_menu_sub.Append(wx.ID_COLS_ALL, "&Select all", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu_sub.Append(wx.ID_COLS_NONE, "&Unselect all", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.AppendMenu(wx.NewId(), "&Column selection", wxglade_tmp_menu_sub, "")
        wxglade_tmp_menu.Append(wx.ID_CHPATH, "&Paths...", "", wx.ITEM_NORMAL)
        wxglade_tmp_menu.Append(wx.ID_GETXCOM, "&Download and install xcom...", "", wx.ITEM_NORMAL)
        self.Pyxcom_menubar.Append(wxglade_tmp_menu, "&Settings")
        wxglade_tmp_menu = wx.Menu()
        wxglade_tmp_menu.Append(wx.ID_ABOUT, "&About...", "", wx.ITEM_NORMAL)
        self.Pyxcom_menubar.Append(wxglade_tmp_menu, "&Help")
        # Menu Bar end
        self.Pyxcom_statusbar = self.CreateStatusBar(1, 0)

        # Tool Bar
        self.Pyxcom_toolbar = wx.ToolBar(self, -1)
        self.SetToolBar(self.Pyxcom_toolbar)
        # Tool Bar end
        self.Z_spin_ctrl = wx.SpinCtrl(self.Msnotebook_1, -1, "1", min=1, max=100)
        self.chem_combo_box = wx.ComboBox(self.MSnotebook_2, -1, choices=["H2", "O2", "N2", "NaCl", "CH4"], style=wx.CB_DROPDOWN|wx.CB_SORT)
        self.std_grid_label = wx.StaticText(self.Enotebook_1, -1, "Just click Calculate button for\nthe xcom standard energy\ngrid of the selected element", style=wx.ALIGN_CENTRE)
        self.Elist_text_ctrl = wx.TextCtrl(self.Enotebook_2, -1, "Insert energies separated by spaces on a single line or in multiple lines.\nA valid example is:\n1 2\n3 4\n", style=wx.TE_MULTILINE|wx.TE_LINEWRAP)
        self.min_label = wx.StaticText(self.Enotebook_3, -1, "Min")
        self.min_spin_ctrl = wx.SpinCtrl(self.Enotebook_3, -1, "1", min=0, max=1000000)
        self.max_label = wx.StaticText(self.Enotebook_3, -1, "Max")
        self.max_spin_ctrl = wx.SpinCtrl(self.Enotebook_3, -1, "100", min=0, max=1000000)
        self.output_text_ctrl = wx.TextCtrl(self, -1, "Pyxcom\na python interface to xcom", style=wx.TE_MULTILINE|wx.HSCROLL|wx.TE_LINEWRAP)
        self.btn_calculate = wx.Button(self, wx.ID_CALC, "&Calculate")
        self.btn_save = wx.Button(self, wx.ID_SAVEAS, "&Save")
        self.btn_debug = wx.Button(self, wx.ID_DEBUG, "&Debug")
        self.btn_exit = wx.Button(self, wx.ID_EXIT, "&Exit")

        self.__set_properties()
        self.__do_layout()
        # end wxGlade

        wx.EVT_MENU(self, wx.ID_EXIT, self.OnCloseWindow)
        wx.EVT_MENU(self, wx.ID_ABOUT, self.OnShowInfo)
        wx.EVT_MENU(self, wx.ID_SAVEAS, self.OnSaveAs)
        wx.EVT_MENU(self, wx.ID_CALC, self.OnCalculate)
        wx.EVT_MENU(self, wx.ID_CHPATH, self.OnChangePath)
        wx.EVT_MENU(self, wx.ID_GETXCOM, self.OnGetXcom)
        wx.EVT_MENU(self, wx.ID_COLS_ALL, self.OnColsAll)
        wx.EVT_MENU(self, wx.ID_COLS_NONE, self.OnColsNone)
        wx.EVT_MENU(self, wx.ID_COLGUI, self.OnColGui)
        wx.EVT_BUTTON(self, wx.ID_DEBUG, self.OnDebug)
        wx.EVT_BUTTON(self, wx.ID_EXIT, self.OnCloseWindow)
        wx.EVT_BUTTON(self, wx.ID_SAVEAS, self.OnSaveAs)
        wx.EVT_BUTTON(self, wx.ID_CALC, self.OnCalculate)

    def __set_properties(self):
        # begin wxGlade: PyxcomFrame.__set_properties
        self.SetTitle("Pyxcom")
        self.Pyxcom_statusbar.SetStatusWidths([-1])
        # statusbar fields
        Pyxcom_statusbar_fields = ["Pyxcom_statusbar"]
        for i in range(len(Pyxcom_statusbar_fields)):
            self.Pyxcom_statusbar.SetStatusText(Pyxcom_statusbar_fields[i], i)
        self.Pyxcom_toolbar.Realize()
        self.chem_combo_box.SetSelection(0)
        self.output_text_ctrl.SetFont(wx.Font(8, wx.DEFAULT, wx.NORMAL, wx.NORMAL, 0, "Bitstream Vera Sans"))
        # end wxGlade
        for i in (0, 6): self.Pyxcom_menubar.Check(wx.ID_COLS[i], True)

    def __do_layout(self):
        # begin wxGlade: PyxcomFrame.__do_layout
        outer_sizer = wx.BoxSizer(wx.VERTICAL)
        Btn_sizer = wx.BoxSizer(wx.HORIZONTAL)
        Esizer = wx.StaticBoxSizer(self.Esizer_staticbox, wx.HORIZONTAL)
        Enb_3sizer = wx.BoxSizer(wx.HORIZONTAL)
        Enb_2sizer = wx.BoxSizer(wx.VERTICAL)
        Enb_1sizer = wx.BoxSizer(wx.VERTICAL)
        MSsizer = wx.StaticBoxSizer(self.MSsizer_staticbox, wx.HORIZONTAL)
        MSnb_2sizer = wx.BoxSizer(wx.HORIZONTAL)
        MSnb_1sizer = wx.BoxSizer(wx.HORIZONTAL)
        MSnb_1sizer.Add(self.Z_spin_ctrl, 0, wx.ALL|wx.ALIGN_CENTER_VERTICAL, 10)
        MSnb_1sizer.Add((0, 48), 0, 0, 0)
        self.Msnotebook_1.SetSizer(MSnb_1sizer)
        MSnb_2sizer.Add(self.chem_combo_box, 1, wx.ALL|wx.ALIGN_CENTER_VERTICAL, 10)
        self.MSnotebook_2.SetSizer(MSnb_2sizer)
        self.MSnotebook.AddPage(self.Msnotebook_1, "Atomic number")
        self.MSnotebook.AddPage(self.MSnotebook_2, "Chemical formula")
        MSsizer.Add(self.MSnotebook, 1, wx.EXPAND, 0)
        outer_sizer.Add(MSsizer, 1, wx.EXPAND, 0)
        Enb_1sizer.Add(self.std_grid_label, 0, wx.ALL|wx.EXPAND|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 20)
        self.Enotebook_1.SetSizer(Enb_1sizer)
        Enb_2sizer.Add(self.Elist_text_ctrl, 1, wx.ALL|wx.EXPAND|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        self.Enotebook_2.SetSizer(Enb_2sizer)
        Enb_3sizer.Add(self.min_label, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 10)
        Enb_3sizer.Add(self.min_spin_ctrl, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        Enb_3sizer.Add(self.max_label, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 20)
        Enb_3sizer.Add(self.max_spin_ctrl, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        self.Enotebook_3.SetSizer(Enb_3sizer)
        self.Enotebook.AddPage(self.Enotebook_1, "Standard grid")
        self.Enotebook.AddPage(self.Enotebook_2, "Energy list")
        self.Enotebook.AddPage(self.Enotebook_3, "Energy range")
        Esizer.Add(self.Enotebook, 1, wx.EXPAND, 0)
        outer_sizer.Add(Esizer, 0, wx.EXPAND, 0)
        outer_sizer.Add(self.output_text_ctrl, 2, wx.ALL|wx.EXPAND, 0)
        Btn_sizer.Add(self.btn_calculate, 0, wx.LEFT|wx.RIGHT|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 10)
        Btn_sizer.Add(self.btn_save, 0, wx.LEFT|wx.RIGHT|wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 10)
        Btn_sizer.Add((200, 0), 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALIGN_CENTER_VERTICAL, 0)
        Btn_sizer.Add(self.btn_debug, 0, wx.LEFT|wx.RIGHT|wx.ALIGN_CENTER_VERTICAL, 10)
        Btn_sizer.Add(self.btn_exit, 0, wx.LEFT|wx.RIGHT|wx.ALIGN_CENTER_VERTICAL, 10)
        outer_sizer.Add(Btn_sizer, 0, wx.ALL|wx.ALIGN_CENTER_HORIZONTAL, 10)
        self.SetSizer(outer_sizer)
        outer_sizer.Fit(self)
        self.Layout()
        # end wxGlade

    def OnCalculate(self, event):
        flags = {"mat" : None, 'range':None, "Z":"29", 'columns':[], 'X':False, 'standard':False, 'quiet':False}
        for i, col in enumerate(wx.ID_COLS):
            if self.Pyxcom_menubar.IsChecked(col): flags['columns'].append(i-8)
        ActiveTab=self.MSnotebook.GetSelection()
        # Parsing first notebook
        if ActiveTab==0:
            flags['Z']=str(self.Z_spin_ctrl.GetValue())
            flags['use_element']=True
        if ActiveTab==1:
            flags['mat']=self.chem_combo_box.GetValue()
            flags['use_element']=False
        # Parsing second notebook
        ActiveTab=self.Enotebook.GetSelection()
        if ActiveTab==-1:
            pass
        elif ActiveTab==0:
            flags['standard']=True
            args=[]
        elif ActiveTab==1:
            args=[x for x in str(self.Elist_text_ctrl.GetValue()).split() if x.isdigit()]
        elif ActiveTab==2:
            Emin, Emax=map(int, (self.min_spin_ctrl.GetValue(), self.max_spin_ctrl.GetValue()))
            args=map(str, range(Emin, Emax+1))
        # calculating new output
        new_text=pxglob.tui(args, flags)
        self.data=new_text
        self.debug='\n'.join([line[2:] for line in new_text.split('\n') if line[0]=='#'][:-1])
        self.output_text_ctrl.SetValue(self.data)
        self.output_text_ctrl.SetFont(wx.Font(9, wx.TELETYPE, wx.NORMAL, wx.NORMAL, 0, "Nimbus Mono L"))
        self.output_text_ctrl.SetFont(wx.Font(10, wx.TELETYPE, wx.NORMAL, wx.NORMAL, 0, "Nimbus Mono L"))

    def OnCloseWindow(self, event):
        # tell the window to kill itself
        ExitDialog=wx.MessageDialog(self, "Really exit?", "Exit dialog", wx.YES_NO|wx.ICON_QUESTION)
        if ExitDialog.ShowModal()==wx.ID_YES:
            self.Destroy()

    def OnDebug(self, event):
        self.output_text_ctrl.SetValue(self.debug)

    def OnShowInfo(self, event):
        # Info Message Dialog
        InfoMessage='''Program realized by\nAlessandro Pisa\ndarkmoon@altervista.org'''
        wx.MessageDialog(self, InfoMessage, "About", wx.ICON_INFORMATION, wx.DefaultPosition).ShowModal()

    def OnSaveAs(self, event):
        # Save output window content
        filename=wx.FileSelector("Choose a file to save the output of pyxcom-gui")
        self.output_text_ctrl.SaveFile(filename)

    def OnChangePath(self, event):
        # Change pyxcom settings
        PathDialog(self, -1, 'Ciao').ShowModal()

    def OnColsAll(self, event):
        for col in wx.ID_COLS:
            self.Pyxcom_menubar.Check(col, True)

    def OnColsNone(self, event):
        for col in wx.ID_COLS: self.Pyxcom_menubar.Check(col, False)

    def OnColGui(self, event):
        cols=[]
        for i, col in enumerate(wx.ID_COLS):
            if self.Pyxcom_menubar.IsChecked(col): cols.append(i-8)
        MyDialog1(self, -1, 'ciao').ShowModal()

    def OnGetXcom(self, event):
        # get xcom from internet
        InstallDialog=wx.MessageDialog(self, "Do you want to download xcom?", "Pyxcom configuration dialog", wx.YES_NO|wx.ICON_QUESTION)
        answer=InstallDialog.ShowModal()
        if answer==wx.ID_YES:
            # wgetting xcom
            Dirdialog=wx.DirDialog(self, "Where do you want to store xcom?", "/tmp", wx.DD_NEW_DIR_BUTTON)
            Dirdialog.ShowModal()
            TMPDIR=Dirdialog.GetPath()
            pxglob.os.system('wget %s -P %s' % (pxglob.XCOM_URL, TMPDIR))

            # Installing xcom
            Dirdialog=wx.DirDialog(self, "Where do you want to install xcom?", "/opt", wx.DD_NEW_DIR_BUTTON)
            Dirdialog.ShowModal()
            XCOMDIR=Dirdialog.GetPath()
            pxglob.os.system('tar xzf %s/XCOM.tar.gz -C %s' % (TMPDIR, XCOMDIR))
            if pxglob.os.path.isdir(pxglob.os.path.join(XCOMDIR, 'XCOM')):
                # Compile xcom and seth path
                pxglob.os.chdir(XCOMDIR)
                pxglob.os.system('mv XCOM xcom')
                XCOMDIR=pxglob.os.path.join(XCOMDIR, 'xcom')
                pxglob.os.chdir(XCOMDIR)
                pxglob.os.system('g77 XCOM.f -o xcom')
                XCOMBIN=pxglob.os.path.join(XCOMDIR, 'xcom')
                pxglob.update_conf(XCOMDIR, XCOMBIN)
            else:
                # Unable to install xcom
                wx.MessageDialog(self, "Xcom was not unpacked!\n(Maybe permission problems)", "Pyxcom configuration dialog").ShowModal()

            # Remove the downloaded package if needed
            InstallDialog=wx.MessageDialog(self, "Do you want to remove the downloaded package?", "Pyxcom configuration dialog", wx.YES_NO|wx.ICON_QUESTION)
            answer=InstallDialog.ShowModal()
            if answer==wx.ID_YES:
                pxglob.os.system('rm -f %s' % pxglob.os.path.join(TMPDIR, 'XCOM.tar.gz'))


# end of class PyxcomFrame

class PyxcomApp(wx.App):
    """Main window"""
    # wxWindows calls this method to initialize the application
    def OnInit(self):
        # Create an instance of our customized Frame class
        frame = PyxcomFrame(None, -1, "Pyxcom")
        frame.Show(True)

        # Tell wxWindows that this is our main window
        self.SetTopWindow(frame)

        # Return a success flag
        return True


def gui_mode():
    """USAGE: gui_mode(opts, args, flags)

    commands this program from a simple GUI.
    """
    wxgui = PyxcomApp(-1)
    wxgui.MainLoop()

if __name__=='__main__':
    gui_mode()
